diff --git a/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java b/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java
index c56abf098..ca39d4ace 100644
--- a/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java
+++ b/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java
@@ -1175,22 +1174,22 @@ public class ClientPacketHandler extends PacketHandler
     }
     
     @Override
-    public void handleIds(SyncIDsPacket packet) {
-    	SoundTypes.setSoundIds(packet.soundIds);
+    public void handleIds(SyncIDsPacket syncIDsPacket) {
+    	SoundTypes.setSoundIds(syncIDsPacket.soundIds);
     }
     
     @Override
-    public void handleCustomPayload(CustomPayloadPacket packet) {
-        if("BTA|RainbowStart".equals(packet.channel)) {
+    public void handleCustomPayload(CustomPayloadPacket customPayloadPacket) {
+        if("BTA|RainbowStart".equals(customPayloadPacket.channel)) {
 //            System.out.printf("b0:%s b1:%s b2:%s b3:%s\n", packet.data[0], packet.data[1], packet.data[2], packet.data[3]);
-            int rainbowTicks = Byte.toUnsignedInt(packet.data[0]) << 24 | Byte.toUnsignedInt(packet.data[1]) << 16 | Byte.toUnsignedInt(packet.data[2]) << 8 | Byte.toUnsignedInt(packet.data[3]);
+            int rainbowTicks = Byte.toUnsignedInt(customPayloadPacket.data[0]) << 24 | Byte.toUnsignedInt(customPayloadPacket.data[1]) << 16 | Byte.toUnsignedInt(customPayloadPacket.data[2]) << 8 | Byte.toUnsignedInt(customPayloadPacket.data[3]);
 //            System.out.println("Added rainbow with " + rainbowTicks + " ticks");
             worldClient.addRainbow(rainbowTicks);
         }
     }
 
     @Override
-    public void handleCommandManagerPacket(CommandManagerPacket packet) {
-        ChatSuggestionsElement.serverSuggestions = packet.suggestions;
+    public void handleCommandManagerPacket(CommandManagerPacket commandManagerPacket) {
+        ChatSuggestionsElement.serverSuggestions = commandManagerPacket.suggestions;
     }
 }
diff --git a/src/main/java/net/minecraft/client/net/handler/PingPacketHandler.java b/src/main/java/net/minecraft/client/net/handler/PingPacketHandler.java
index 1ba52c28e..30702b888 100644
--- a/src/main/java/net/minecraft/client/net/handler/PingPacketHandler.java
+++ b/src/main/java/net/minecraft/client/net/handler/PingPacketHandler.java
@@ -81,7 +81,7 @@ public class PingPacketHandler
 
 
     @Override
-    public void handleErrorMessage(String s, Object[] aobj) {
+    public void handleErrorMessage(String message, Object[] objects) {
         if (!disconnected) {
             disconnected = true;
         }
diff --git a/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java b/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
index 3a00c9c1d..bc8500f4c 100644
--- a/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
+++ b/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
@@ -41,17 +41,17 @@ public class PlayerControllerMP extends PlayerController {
 	@Override
 	protected void hitBlock(int x, int y, int z, Side side, double xHit, double yHit) {
 		super.hitBlock(x, y, z, side, xHit, yHit);
-		netHandler.addToSendQueue(new PlayerActionPacket(1, x, y, z, side, xHit, yHit));
+		netHandler.addToSendQueue(new PlayerActionPacket(PlayerActionPacket.ACTION_DIG_CONTINUED, x, y, z, side, xHit, yHit));
 	}
 	
 	@Override
 	public void sendStartDigPacket(int x, int y, int z, Side side, double xHit, double yHit) {
-		netHandler.addToSendQueue(new PlayerActionPacket(0, x, y, z, side, xHit, yHit));
+		netHandler.addToSendQueue(new PlayerActionPacket(PlayerActionPacket.ACTION_DIG_START, x, y, z, side, xHit, yHit));
 	}
 	
 	@Override
 	public void sendDestroyBlockPacket(int x, int y, int z, Side side, double xHit, double yHit) {
-		netHandler.addToSendQueue(new PlayerActionPacket(2, x, y, z, side, xHit, yHit));
+		netHandler.addToSendQueue(new PlayerActionPacket(PlayerActionPacket.ACTION_DIG_COMPLETE, x, y, z, side, xHit, yHit));
 	}
 	
 	@Override
diff --git a/src/main/java/net/minecraft/client/render/RenderGlobal.java b/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 44cc472e5..c17ab72bd 100644
--- a/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -486,23 +486,23 @@ public class RenderGlobal
         return "E: " + countEntitiesRendered + "/" + countEntitiesTotal + ". B: " + countEntitiesHidden + ", I: " + (countEntitiesTotal - countEntitiesHidden - countEntitiesRendered);
     }
 
-    public void markRenderersForNewPosition(int i, int j, int k)
+    public void markRenderersForNewPosition(int x, int y, int z)
     {
-        i -= 8;
-        j -= 8;
-        k -= 8;
-        minBlockX = 0x7fffffff;
-        minBlockY = 0x7fffffff;
-        minBlockZ = 0x7fffffff;
-        maxBlockX = 0x80000000;
-        maxBlockY = 0x80000000;
-        maxBlockZ = 0x80000000;
+        x -= 8;
+        y -= 8;
+        z -= 8;
+        minBlockX = Integer.MAX_VALUE;
+        minBlockY = Integer.MAX_VALUE;
+        minBlockZ = Integer.MAX_VALUE;
+        maxBlockX = Integer.MIN_VALUE;
+        maxBlockY = Integer.MIN_VALUE;
+        maxBlockZ = Integer.MIN_VALUE;
         int l = renderChunksWide * RENDER_CHUNK_SIZE;
         int i1 = l / 2;
         for(int j1 = 0; j1 < renderChunksWide; j1++)
         {
             int k1 = j1 * RENDER_CHUNK_SIZE;
-            int l1 = (k1 + i1) - i;
+            int l1 = (k1 + i1) - x;
             if(l1 < 0)
             {
                 l1 -= l - 1;
@@ -520,7 +520,7 @@ public class RenderGlobal
             for(int i2 = 0; i2 < renderChunksDeep; i2++)
             {
                 int j2 = i2 * RENDER_CHUNK_SIZE;
-                int k2 = (j2 + i1) - k;
+                int k2 = (j2 + i1) - z;
                 if(k2 < 0)
                 {
                     k2 -= l - 1;
diff --git a/src/main/java/net/minecraft/client/render/WorldRenderer.java b/src/main/java/net/minecraft/client/render/WorldRenderer.java
index db4b333fb..ee3a6b8ba 100644
--- a/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -439,8 +439,8 @@ public class WorldRenderer
 					l = -1;
 				}
 				if(mc.gameSettings.smoothCamera.value) {
-					deltaX = mouseFilterXAxis.func_22386_a(deltaX, 0.05F * sensitivity);
-					deltaY = mouseFilterYAxis.func_22386_a(deltaY, 0.05F * sensitivity);
+					deltaX = mouseFilterXAxis.getSmoothedDelta(deltaX, 0.05F * sensitivity);
+					deltaY = mouseFilterYAxis.getSmoothedDelta(deltaY, 0.05F * sensitivity);
 				} else {
                     mouseFilterXAxis.reset();
                     mouseFilterYAxis.reset();
diff --git a/src/main/java/net/minecraft/client/render/block/model/ActivatorBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/ActivatorBlockModel.java
index d9161bf31..b12ff14a2 100644
--- a/src/main/java/net/minecraft/client/render/block/model/ActivatorBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/ActivatorBlockModel.java
@@ -3,17 +3,26 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.ActivatorBlock;
-import net.minecraft.core.block.FullRotatableBlock;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.VeryRotatableEntityBlock;
-import net.minecraft.core.block.RotatableBlock;
-import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.helper.Sides;
 
 public class ActivatorBlockModel extends VeryRotatableBlockModel<ActivatorBlock> {
-    public final IconCoordinate frontPowered = TextureRegistry.getTexture("minecraft:block/activator_front_active");
-    public final IconCoordinate frontOverbright = TextureRegistry.getTexture("minecraft:block/activator_front_active_overlay");
+    public final IconCoordinate[] poweredTextures = {
+        null,
+        TextureRegistry.getTexture("minecraft:block/activator_top_active"),
+        TextureRegistry.getTexture("minecraft:block/activator_side_active"),
+        TextureRegistry.getTexture("minecraft:block/activator_front_active"),
+        TextureRegistry.getTexture("minecraft:block/activator_side_active"),
+        TextureRegistry.getTexture("minecraft:block/activator_side_active")
+    };
+    public final IconCoordinate[] overbrightTextures = {
+        null,
+        TextureRegistry.getTexture("minecraft:block/activator_top_active_overlay"),
+        TextureRegistry.getTexture("minecraft:block/activator_side_active_overlay"),
+        TextureRegistry.getTexture("minecraft:block/activator_front_active_overlay"),
+        TextureRegistry.getTexture("minecraft:block/activator_side_active_overlay"),
+        TextureRegistry.getTexture("minecraft:block/activator_side_active_overlay")
+    };
     public ActivatorBlockModel(Block block) {
         super(block);
     }
@@ -26,24 +35,18 @@ public class ActivatorBlockModel extends VeryRotatableBlockModel<ActivatorBlock>
     @Override
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
-        boolean isPowered = (data & ActivatorBlock.MASK_POWERED) != 0;
-        final Direction dir = VeryRotatableEntityBlock.metaToDirection(data);
-        if (side == dir.getSide()) {
-            return isPowered ? frontPowered : atlasIndices[Side.TOP.getId()];
+        if ((data & ActivatorBlock.MASK_POWERED) != 0) {
+            return poweredTextures[getTextureIndex(side, data)];
+        } else {
+            return super.getBlockTextureFromSideAndMetadata(side, data);
         }
-        if (side == Side.BOTTOM || side == Side.TOP) return atlasIndices[Side.BOTTOM.getId()];
-        if ((dir.getSide() == Side.BOTTOM || dir.getSide() == Side.TOP) && (side == Side.NORTH || side == Side.SOUTH)) return atlasIndices[Side.BOTTOM.getId()];
-        return side.getDirection() != dir.getOpposite() ? atlasIndices[Side.NORTH.getId()] : atlasIndices[Side.BOTTOM.getId()];
     }
 
     @Override
     public IconCoordinate getBlockOverbrightTextureFromSideAndMeta(Side side, int data)
     {
         boolean isPowered = (data & ActivatorBlock.MASK_POWERED) != 0;
-        if(isPowered && side.getId() == FullRotatableBlock.metaToDirection(data).getSide().getId())
-        {
-            return frontOverbright;
-        }
-        return null;
+        if (!isPowered) return null;
+        return overbrightTextures[getTextureIndex(side, data)];
     }
 }
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index 21bccd4cd..58ebdff08 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -333,8 +333,8 @@ public class BlockModelDispatcher
 
         addDispatch(new SpikesBlockModel<>(Blocks.SPIKES).withTextures("minecraft:block/spikes_top", "minecraft:block/spikes_bottom", "minecraft:block/spikes_side"));
 
-        addDispatch(new VeryRotatableBlockModel<>(Blocks.DISPENSER_COBBLE_STONE).withTextures("minecraft:block/dispenser_front", "minecraft:block/dispenser_top", "minecraft:block/dispenser_side"));
-        addDispatch(new ActivatorBlockModel(Blocks.ACTIVATOR_COBBLE_NETHERRACK).withTextures("minecraft:block/activator_front", "minecraft:block/activator_top", "minecraft:block/activator_side"));
+        addDispatch(new VeryRotatableBlockModel<>(Blocks.DISPENSER_COBBLE_STONE).withTextures("minecraft:block/dispenser_top", "minecraft:block/dispenser_bottom", "minecraft:block/dispenser_side", "minecraft:block/dispenser_side", "minecraft:block/dispenser_front", "minecraft:block/dispenser_side"));
+        addDispatch(new ActivatorBlockModel(Blocks.ACTIVATOR_COBBLE_NETHERRACK).withTextures("minecraft:block/activator_top", "minecraft:block/activator_bottom", "minecraft:block/activator_side", "minecraft:block/activator_side", "minecraft:block/activator_front", "minecraft:block/activator_side"));
 
         addDispatch(new TrapDoorBlockModel<>(Blocks.TRAPDOOR_PLANKS_OAK).withTextures("minecraft:block/trapdoor_planks_oak_top", "minecraft:block/trapdoor_planks_oak_side"));
         addDispatch(new TrapDoorBlockModel<>(Blocks.TRAPDOOR_IRON).withTextures("minecraft:block/trapdoor_iron_top", "minecraft:block/trapdoor_iron_side"));
@@ -352,8 +352,8 @@ public class BlockModelDispatcher
         addDispatch(new PaintedDoorBlockModel<>(Blocks.DOOR_PLANKS_PAINTED_TOP, true).withTextures("minecraft:block/trapdoor_planks_oak_top", "minecraft:block/door_planks_oak_top"));
         addDispatch(new GlassDoorBlockModel<>(Blocks.DOOR_GLASS_BOTTOM).withTextures("minecraft:block/glass", "minecraft:block/door_glass_bottom"));
         addDispatch(new GlassDoorBlockModel<>(Blocks.DOOR_GLASS_TOP).withTextures("minecraft:block/glass", "minecraft:block/door_glass_top"));
-        addDispatch(new DoorBlockModel<>(Blocks.DOOR_STEEL_BOTTOM).withTextures("minecraft:block/trapdoor_steel_top", "minecraft:block/door_steel_bottom"));
-        addDispatch(new DoorBlockModel<>(Blocks.DOOR_STEEL_TOP).withTextures("minecraft:block/trapdoor_steel_top", "minecraft:block/door_steel_top"));
+        addDispatch(new DoorBlockModel<>(Blocks.DOOR_STEEL_BOTTOM).withTextures("minecraft:block/door_steel_frame_top", "minecraft:block/door_steel_bottom"));
+        addDispatch(new DoorBlockModel<>(Blocks.DOOR_STEEL_TOP).withTextures("minecraft:block/door_steel_frame_top", "minecraft:block/door_steel_top"));
 
         addDispatch(new TransparentBlockModel<>(Blocks.MESH, true).withTextures("minecraft:block/mesh"));
         addDispatch(new TransparentBlockModel<>(Blocks.MESH_GOLD, true).withTextures("minecraft:block/mesh_gold"));
@@ -371,8 +371,8 @@ public class BlockModelDispatcher
 
         addDispatch(new StandardBlockModel<>(Blocks.WORKBENCH).withTextures("minecraft:block/workbench_top", "minecraft:block/planks_oak", "minecraft:block/workbench_front", "minecraft:block/workbench_side", "minecraft:block/workbench_front", "minecraft:block/workbench_side"));
 
-        addDispatch(new FurnaceBlockModel<>(Blocks.FURNACE_STONE_IDLE).withTextures("minecraft:block/furnace_stone_top", "minecraft:block/furnace_stone_top", "minecraft:block/furnace_stone_idle_front", "minecraft:block/furnace_stone_side", "minecraft:block/furnace_stone_side", "minecraft:block/furnace_stone_side"));
-        addDispatch(new FurnaceBlockModel<>(Blocks.FURNACE_STONE_ACTIVE).withTextures("minecraft:block/furnace_stone_top", "minecraft:block/furnace_stone_top", "minecraft:block/furnace_stone_active_front", "minecraft:block/furnace_stone_side", "minecraft:block/furnace_stone_side", "minecraft:block/furnace_stone_side"));
+        addDispatch(new FurnaceBlockModel<>(Blocks.FURNACE_STONE_IDLE).withTextures("minecraft:block/furnace_stone_top", "minecraft:block/furnace_stone_bottom", "minecraft:block/furnace_stone_idle_front", "minecraft:block/furnace_stone_side", "minecraft:block/furnace_stone_side", "minecraft:block/furnace_stone_side"));
+        addDispatch(new FurnaceBlockModel<>(Blocks.FURNACE_STONE_ACTIVE).withTextures("minecraft:block/furnace_stone_top", "minecraft:block/furnace_stone_bottom", "minecraft:block/furnace_stone_active_front", "minecraft:block/furnace_stone_side", "minecraft:block/furnace_stone_side", "minecraft:block/furnace_stone_side"));
         addDispatch(new FurnaceBlockModel<>(Blocks.FURNACE_BLAST_IDLE).withTextures("minecraft:block/furnace_blast_top", "minecraft:block/furnace_blast_bottom", "minecraft:block/furnace_blast_idle_front", "minecraft:block/furnace_blast_side", "minecraft:block/furnace_blast_side", "minecraft:block/furnace_blast_side"));
         addDispatch(new FurnaceBlockModel<>(Blocks.FURNACE_BLAST_ACTIVE).withTextures("minecraft:block/furnace_blast_top", "minecraft:block/furnace_blast_bottom", "minecraft:block/furnace_blast_active_front", "minecraft:block/furnace_blast_side", "minecraft:block/furnace_blast_side", "minecraft:block/furnace_blast_side"));
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/CacaoLeavesBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/CacaoLeavesBlockModel.java
index 8ab16cc30..32f2dda26 100644
--- a/src/main/java/net/minecraft/client/render/block/model/CacaoLeavesBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/CacaoLeavesBlockModel.java
@@ -5,6 +5,7 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.CacaoLeavesBlock;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
@@ -16,13 +17,14 @@ public class CacaoLeavesBlockModel<T extends Block> extends LeavesBlockModel<T>
             TextureRegistry.getTexture("minecraft:block/leaves_cacao_bean_stage3")};
     public CacaoLeavesBlockModel(Block block) {
         super(block, "minecraft:block/leaves_cacao");
+        assert growthStages.length == CacaoLeavesBlock.MAX_GROWTH_STATE : "There must be a texture associated with every cacao bean stage!";
     }
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
         super.render(tessellator, x, y, z);
 
-        final int growthRate = (renderBlocks.blockAccess.getBlockMetadata(x, y, z) & 0XF0) >> 4;
+        final int growthRate = CacaoLeavesBlock.getGrowthRate(renderBlocks.blockAccess.getBlockMetadata(x, y, z));
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
             int lmc = block.getLightmapCoord(renderBlocks.blockAccess, x, y, z);
@@ -40,7 +42,7 @@ public class CacaoLeavesBlockModel<T extends Block> extends LeavesBlockModel<T>
         final float cNorthSouth = 0.8F;
         final float cEastWest = 0.6F;
         if (growthRate > 0) {
-            renderBlocks.overrideBlockTexture = growthStages[Math.min(growthRate - 1, 3)];
+            renderBlocks.overrideBlockTexture = growthStages[Math.min(growthRate - 1, CacaoLeavesBlock.MAX_GROWTH_STATE - 1)];
             tessellator.setColorOpaque_F(cNorthSouth * brightness, cNorthSouth * brightness, cNorthSouth * brightness);
             renderNorthFace(tessellator, block, x, y, z, renderBlocks.overrideBlockTexture);
             renderSouthFace(tessellator, block, x, y, z, renderBlocks.overrideBlockTexture);
@@ -57,7 +59,7 @@ public class CacaoLeavesBlockModel<T extends Block> extends LeavesBlockModel<T>
         super.renderBlockOnInventory(tessellator, metadata, brightness, alpha, lightmapCoordinate);
         GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
 
-        final IconCoordinate cacaoCoord = growthStages[3];
+        final IconCoordinate cacaoCoord = growthStages[CacaoLeavesBlock.MAX_GROWTH_STATE - 1];
         GL11.glColor4f(brightness, brightness, brightness, alpha);
 
         tessellator.startDrawingQuads();
diff --git a/src/main/java/net/minecraft/client/render/block/model/CropsWheatBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/CropsWheatBlockModel.java
index 516b1c711..e41c614f2 100644
--- a/src/main/java/net/minecraft/client/render/block/model/CropsWheatBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/CropsWheatBlockModel.java
@@ -5,6 +5,7 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.CropsWheatBlock;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 
@@ -22,6 +23,7 @@ public class CropsWheatBlockModel<T extends Block> extends StandardBlockModel<T>
 
     public CropsWheatBlockModel(Block block) {
         super(block);
+        assert growthStageTextures.length == CropsWheatBlock.MAX_GROWTH_STATE + 1 : "There must be a texture for each wheat growth stage!";
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/render/block/model/DoorBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/DoorBlockModel.java
index 391d4e5bf..7af28c992 100644
--- a/src/main/java/net/minecraft/client/render/block/model/DoorBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/DoorBlockModel.java
@@ -119,7 +119,7 @@ public class DoorBlockModel<T extends DoorBlock> extends StandardBlockModel<T> {
     }
     protected boolean shouldFlipTexture(Side side, int meta){
         if(side == Side.TOP || side == Side.BOTTOM) return false;
-        int state = block.getState(meta);
+        int state = block.getRotation(meta);
         int l = state / 2 + (side.getId() & 1 ^ state);
         if((state == 0 || state == 2) ^ (side.getId() <= 3))
         {
diff --git a/src/main/java/net/minecraft/client/render/block/model/FenceGateBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/FenceGateBlockModel.java
index 76fcf3ee0..ebfcf58ea 100644
--- a/src/main/java/net/minecraft/client/render/block/model/FenceGateBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/FenceGateBlockModel.java
@@ -18,8 +18,8 @@ public class FenceGateBlockModel<T extends FenceGateBlock> extends StandardBlock
         block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         boolean flag = true;
         int l = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
-        boolean flag1 = FenceGateBlock.func_35291_d(l);
-        int i1 = FenceGateBlock.func_35290_f(l);
+        boolean flag1 = FenceGateBlock.isOpen(l);
+        int i1 = FenceGateBlock.getDirection(l);
         if(i1 == 3 || i1 == 1)
         {
             float f = 0.4375F;
diff --git a/src/main/java/net/minecraft/client/render/block/model/LanternBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/LanternBlockModel.java
index a0197810e..970eb9922 100644
--- a/src/main/java/net/minecraft/client/render/block/model/LanternBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/LanternBlockModel.java
@@ -4,6 +4,7 @@ import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.FireflyLanternBlock;
 import net.minecraft.core.util.helper.Side;
 
 public class LanternBlockModel<T extends Block> extends StandardBlockModel<T> {
@@ -15,8 +16,8 @@ public class LanternBlockModel<T extends Block> extends StandardBlockModel<T> {
     public boolean render(Tessellator tessellator, int x, int y, int z) {
         block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
-        boolean isHanging = (meta & 0b00000001) == 0;
-        boolean isAngled = (meta & 0b00000010) != 0;
+        boolean isHanging = (meta & FireflyLanternBlock.MASK_HANGING) == 0;
+        boolean isAngled = (meta & FireflyLanternBlock.MASK_ANGLED) != 0;
 
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
diff --git a/src/main/java/net/minecraft/client/render/block/model/TorchBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/TorchBlockModel.java
index 9d980568d..8bf27d21a 100644
--- a/src/main/java/net/minecraft/client/render/block/model/TorchBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/TorchBlockModel.java
@@ -4,6 +4,7 @@ import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.TorchBlock;
 import net.minecraft.core.util.helper.Side;
 
 public class TorchBlockModel<T extends Block> extends StandardBlockModel<T> {
@@ -14,38 +15,36 @@ public class TorchBlockModel<T extends Block> extends StandardBlockModel<T> {
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
         block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
-        int l = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
-        	tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
+            tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
         }else {
-        	brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
-        	if(Block.lightEmission[block.id] > 0) {
-        		brightness = 1.0F;
-        	}
+            brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+            if(Block.lightEmission[block.id] > 0) {
+                brightness = 1.0F;
+            }
         }
         tessellator.setColorOpaque_F(brightness, brightness, brightness);
         double d = 0.4;
         double d1 = 0.5D - d;
         double d2 = 0.2;
-        if(l == 1)
-        {
-            renderTorchAtAngle(tessellator, (double)x - d1, (double)y + d2, z, -d, 0.0D);
-        } else
-        if(l == 2)
-        {
-            renderTorchAtAngle(tessellator, (double)x + d1, (double)y + d2, z, d, 0.0D);
-        } else
-        if(l == 3)
-        {
-            renderTorchAtAngle(tessellator, x, (double)y + d2, (double)z - d1, 0.0D, -d);
-        } else
-        if(l == 4)
-        {
-            renderTorchAtAngle(tessellator, x, (double)y + d2, (double)z + d1, 0.0D, d);
-        } else
-        {
-            renderTorchAtAngle(tessellator, x, y, z, 0.0D, 0.0D);
+        int direction = renderBlocks.blockAccess.getBlockMetadata(x, y, z) & TorchBlock.MASK_DIRECTION;
+        switch (direction) {
+            case TorchBlock.SIDE_WEST:
+                renderTorchAtAngle(tessellator, (double) x - d1, (double) y + d2, z, -d, 0.0D);
+                break;
+            case TorchBlock.SIDE_EAST:
+                renderTorchAtAngle(tessellator, (double) x + d1, (double) y + d2, z, d, 0.0D);
+                break;
+            case TorchBlock.SIDE_NORTH:
+                renderTorchAtAngle(tessellator, x, (double) y + d2, (double) z - d1, 0.0D, -d);
+                break;
+            case TorchBlock.SIDE_SOUTH:
+                renderTorchAtAngle(tessellator, x, (double) y + d2, (double) z + d1, 0.0D, d);
+                break;
+            default:
+                renderTorchAtAngle(tessellator, x, y, z, 0.0D, 0.0D);
+                break;
         }
         return true;
     }
diff --git a/src/main/java/net/minecraft/client/render/block/model/VeryRotatableBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/VeryRotatableBlockModel.java
index 57c6fcf51..be0447f4e 100644
--- a/src/main/java/net/minecraft/client/render/block/model/VeryRotatableBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/VeryRotatableBlockModel.java
@@ -38,12 +38,47 @@ public class VeryRotatableBlockModel<T extends Block> extends StandardBlockModel
     @Override
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
+        return atlasIndices[getTextureIndex(side, data)];
+    }
+
+    public int getTextureIndex(Side side, int data) {
         final Direction dir = VeryRotatableEntityBlock.metaToDirection(data);
-        if (side == dir.getSide()) {
-            return atlasIndices[Side.TOP.getId()];
+        switch (dir) { // I love brute forcing fixes so much :3
+            case SOUTH:
+                return side.getId();
+            case EAST:
+                return side.getDirection().rotate(1).getId();
+            case NORTH:
+                return side.getDirection().rotate(2).getId();
+            case WEST:
+                return side.getDirection().rotate(3).getId();
+            case UP:
+                switch (side) {
+                    case NORTH:
+                        return Side.TOP.getId();
+                    case SOUTH:
+                        return Side.BOTTOM.getId();
+                    case TOP:
+                        return Side.SOUTH.getId();
+                    case BOTTOM:
+                        return Side.NORTH.getId();
+                    default:
+                        return side.getId();
+                }
+            case DOWN:
+                switch (side) {
+                    case NORTH:
+                        return Side.BOTTOM.getId();
+                    case SOUTH:
+                        return Side.TOP.getId();
+                    case TOP:
+                        return Side.NORTH.getId();
+                    case BOTTOM:
+                        return Side.SOUTH.getId();
+                    default:
+                        return side.getId();
+                }
         }
-        if (side == Side.BOTTOM || side == Side.TOP) return atlasIndices[Side.BOTTOM.getId()];
-        if ((dir.getSide() == Side.BOTTOM || dir.getSide() == Side.TOP) && (side == Side.NORTH || side == Side.SOUTH)) return atlasIndices[Side.BOTTOM.getId()];
-        return side.getDirection() != dir.getOpposite() ? atlasIndices[Side.NORTH.getId()] : atlasIndices[Side.BOTTOM.getId()];
+        return 0;
     }
 }
diff --git a/src/main/java/net/minecraft/client/render/blockentity/SignBlockEntityRenderer.java b/src/main/java/net/minecraft/client/render/blockentity/SignBlockEntityRenderer.java
index 134f0f8f7..2a7cd1496 100644
--- a/src/main/java/net/minecraft/client/render/blockentity/SignBlockEntityRenderer.java
+++ b/src/main/java/net/minecraft/client/render/blockentity/SignBlockEntityRenderer.java
@@ -69,7 +69,7 @@ public class SignBlockEntityRenderer extends BlockEntityRenderer<SignBlockEntity
         loadTexture("/assets/minecraft/textures/entity/sign.png");
         GL11.glPushMatrix();
         GL11.glScalef(scale, -scale, -scale);
-        signModel.func_887_a();
+        signModel.render();
         GL11.glPopMatrix();
         Font font = getFont();
 
